/*
 * My tiny loadable module example
 */
#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/module.h>
#include <sys/sysctl.h>
#include <sys/systm.h>

static int test_sysctl_proc(SYSCTL_HANDLER_ARGS);
SYSCTL_PROC(_debug, OID_AUTO, test, CTLFLAG_RW | CTLTYPE_STRING,
	    __DECONST(char *, "test"), 0, test_sysctl_proc, "A", "");

static int test_int = 0;
SYSCTL_INT(_debug, OID_AUTO, test_int, CTLFLAG_RW, &test_int, 0, "an integer");

static int
test_sysctl_proc(SYSCTL_HANDLER_ARGS)
{
	static char buf[80] = "TEST";
	int err = 0;

	(void)oidp;
	(void)arg1;
	(void)arg2;
	if (req->newptr) {
		snprintf(buf, sizeof(buf), "%.*s", req->newlen,
			 (const char *)req->newptr);
	}
	else
		err = SYSCTL_OUT(req, buf, sizeof(buf));

	return(0);
}

static int
test_evh(struct module *m __unused, int what, void *arg __unused)
{
	int error = 0;

	switch (what) {
	case MOD_LOAD:
		printf("kldload'ing failed intentionally\n");
		error = EOPNOTSUPP;
		break;
	case MOD_UNLOAD:
		printf("kldunload'ing OK\n");
		break;
	default:
		error = EINVAL;
		break;
	}
	return(error);
}

static	moduledata_t test_mod = {
	"test",
	test_evh,
	NULL,
};

DECLARE_MODULE(test, test_mod, SI_SUB_KLD, SI_ORDER_ANY);
